------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------

package body Qt4.Sql_Relations is

   function new_QSqlRelation return not null access Qt4_Entities.Cpp_Class;
   pragma Import (C, new_QSqlRelation, "__Qt4Ada_new_QSqlRelation");

   procedure delete_QSqlRelation
    (Cpp_Object : not null access Qt4_Entities.Cpp_Class);
   pragma Import (C, delete_QSqlRelation, "__Qt4Ada_delete_QSqlRelation");

   function create_QSqlRelation
    (Table_Name     : access Qt4.Strings.Internals.QString;
     Index_Column   : access Qt4.Strings.Internals.QString;
     Display_Column : access Qt4.Strings.Internals.QString)
       return not null access Qt4_Entities.Cpp_Class;
   pragma Import (C, create_QSqlRelation, "__Qt4Ada_create_QSqlRelation");

   function displayColumn_wrapper
    (Self : not null access constant Thin.QSqlRelation)
       return access Qt4.Strings.Internals.QString;
   pragma Import (C,
                  displayColumn_wrapper,
                  "__Qt4Ada_QSqlRelation_displayColumn_wrapper");

   function indexColumn_wrapper
    (Self : not null access constant Thin.QSqlRelation)
       return access Qt4.Strings.Internals.QString;
   pragma Import (C,
                  indexColumn_wrapper,
                  "__Qt4Ada_QSqlRelation_indexColumn_wrapper");

   function isValid_wrapper (Self : access constant Thin.QSqlRelation)
     return Qt4.bool;
   pragma Import (C,
                  isValid_wrapper,
                  "__Qt4Ada_QSqlRelation_isValid_wrapper");

   function tableName_wrapper
    (Self : not null access constant Thin.QSqlRelation)
       return access Qt4.Strings.Internals.QString;
   pragma Import (C,
                  tableName_wrapper,
                  "__Qt4Ada_QSqlRelation_tableName_wrapper");

   procedure assign_QSqlRelation
    (R_1 : not null access          Thin.QSqlRelation;
     R_2 : not null access constant Thin.QSqlRelation);
   pragma Import (C, assign_QSqlRelation, "__Qt4Ada_assign_QSqlRelation");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Copy_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding
   function Copy_Cpp_Object (Self : not null access Q_Sql_Relation)
     return not null access Qt4_Entities.Cpp_Class
   is
   begin
      return Thin.copy_QSqlRelation (Self.Cpp_Object);
   end Copy_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Create
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Create (Table_Name     : Qt4.Strings.Q_String;
                    Index_Column   : Qt4.Strings.Q_String;
                    Display_Column : Qt4.Strings.Q_String)
     return Q_Sql_Relation
   is
   begin
      return Internals.To_Q_Sql_Relation
              (create_QSqlRelation
                (Qt4.Strings.Internals.QString_View (Table_Name),
                 Qt4.Strings.Internals.QString_View (Index_Column),
                 Qt4.Strings.Internals.QString_View (Display_Column)));
   end Create;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Default_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding
   function Default_Cpp_Object (Self : not null access Q_Sql_Relation)
     return access Qt4_Entities.Cpp_Class
   is
      pragma Unreferenced (Self);
      --  Параметр необходим для диспетчеризации надклассового вызова.

   begin
      return new_QSqlRelation;
   end Default_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Delete_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding
   procedure Delete_Cpp_Object (Self : not null access Q_Sql_Relation)
   is
   begin
      delete_QSqlRelation (Self.Cpp_Object);
   end Delete_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Display_Column
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Display_Column (Self : Q_Sql_Relation)
     return Qt4.Strings.Q_String
   is
   begin
      return
        Qt4.Strings.Internals.Create_Wrapper
         (Qt4.Strings.Internals.QString_Access
           (displayColumn_wrapper
             (Qt4.Sql_Relations.Internals.QSqlRelation_View (Self))));
   end Display_Column;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Index_Column
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Index_Column (Self : Q_Sql_Relation)
     return Qt4.Strings.Q_String
   is
   begin
      return
        Qt4.Strings.Internals.Create_Wrapper
         (Qt4.Strings.Internals.QString_Access
           (indexColumn_wrapper
             (Qt4.Sql_Relations.Internals.QSqlRelation_View (Self))));
   end Index_Column;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Is_Valid
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Is_Valid (Self : Q_Sql_Relation) return Boolean is
   begin
      return Qt4.To_Boolean
              (isValid_wrapper
                (Qt4.Sql_Relations.Internals.QSqlRelation_View (Self)));
   end Is_Valid;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Table_Name
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Table_Name (Self : Q_Sql_Relation) return Qt4.Strings.Q_String
   is
   begin
      return
        Qt4.Strings.Internals.Create_Wrapper
         (Qt4.Strings.Internals.QString_Access
           (tableName_wrapper
             (Qt4.Sql_Relations.Internals.QSqlRelation_View (Self))));
   end Table_Name;

   package body Internals is

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> Cpp_Object
      --!    <ImplementationNotes>
      ------------------------------------------------------------------------
      function Cpp_Object (Self : Q_Sql_Relation)
        return not null access Thin.QSqlRelation
      is
      begin
         return Qt4_Entities.Cpp_Object (Self);
      end Cpp_Object;

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> To_Q_Sql_Relation
      --!    <ImplementationNotes>
      ------------------------------------------------------------------------
      function To_Q_Sql_Relation (Item : not null access Thin.QSqlRelation)
        return Q_Sql_Relation is
      begin
         return Result : Q_Sql_Relation do
            assign_QSqlRelation (Internals.QSqlRelation_View (Result), Item);
         end return;
      end To_Q_Sql_Relation;

   end Internals;

end Qt4.Sql_Relations;
